----------------------------------------------------------------------------------

-- 
-- Engineer:  Groupe : ADAM HAMZA AYOUB YOUSSEF
-- 
-- Create Date:    21:28:47 24/05/2015 
-- Design Name: 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity duty is
	port
	(
		addr : in std_logic_vector(6 downto 0);
		data : out std_logic_vector(15 downto 0)
	);
end duty;

architecture rom of duty is
	constant ADDR_WIDTH : integer := 7;
	constant DATA_WIDTH : integer := 16;
	type rom_type is array(0 to 2**ADDR_WIDTH-1) of std_logic_vector(DATA_WIDTH-1 downto 0);
	
	constant duty : rom_type := (1  => std_logic_vector(to_unsigned(500,16)),
										  2  => std_logic_vector(to_unsigned(1000,16)),
										  3  => std_logic_vector(to_unsigned(1500,16)),
										  4  => std_logic_vector(to_unsigned(2000,16)),
										  5  => std_logic_vector(to_unsigned(2500,16)),
										  6  => std_logic_vector(to_unsigned(3000,16)),
										  7  => std_logic_vector(to_unsigned(3500,16)),
										  8  => std_logic_vector(to_unsigned(4000,16)),
										  9  => std_logic_vector(to_unsigned(4500,16)),
										  10 => std_logic_vector(to_unsigned(5000,16)),
										  11 => std_logic_vector(to_unsigned(5500,16)),
										  12 => std_logic_vector(to_unsigned(6000,16)),
										  13 => std_logic_vector(to_unsigned(6500,16)),
										  14 => std_logic_vector(to_unsigned(7000,16)),
										  15 => std_logic_vector(to_unsigned(7500,16)),
										  16 => std_logic_vector(to_unsigned(8000,16)),
										  17 => std_logic_vector(to_unsigned(8500,16)),
										  18 => std_logic_vector(to_unsigned(9000,16)),
										  19 => std_logic_vector(to_unsigned(9500,16)),
										  20 => std_logic_vector(to_unsigned(10000,16)),
										  21 => std_logic_vector(to_unsigned(10500,16)),
										  22 => std_logic_vector(to_unsigned(11000,16)),
										  23 => std_logic_vector(to_unsigned(11500,16)),
										  24 => std_logic_vector(to_unsigned(12000,16)),
										  25 => std_logic_vector(to_unsigned(12500,16)),
										  26 => std_logic_vector(to_unsigned(13000,16)),
										  27 => std_logic_vector(to_unsigned(13500,16)),
										  28 => std_logic_vector(to_unsigned(14000,16)),
										  29 => std_logic_vector(to_unsigned(14500,16)),
										  30 => std_logic_vector(to_unsigned(15000,16)),
										  31 => std_logic_vector(to_unsigned(15500,16)),
										  32 => std_logic_vector(to_unsigned(16000,16)),
										  33 => std_logic_vector(to_unsigned(16500,16)),
										  34 => std_logic_vector(to_unsigned(17000,16)),
										  35 => std_logic_vector(to_unsigned(17500,16)),
										  36 => std_logic_vector(to_unsigned(18000,16)),
										  37 => std_logic_vector(to_unsigned(18500,16)),
										  38 => std_logic_vector(to_unsigned(19000,16)),
										  39 => std_logic_vector(to_unsigned(19500,16)),
										  40 => std_logic_vector(to_unsigned(20000,16)),
										  41 => std_logic_vector(to_unsigned(20500,16)),
										  42 => std_logic_vector(to_unsigned(21000,16)),
										  43 => std_logic_vector(to_unsigned(21500,16)),
										  44 => std_logic_vector(to_unsigned(22000,16)),
										  45 => std_logic_vector(to_unsigned(22500,16)),
										  46 => std_logic_vector(to_unsigned(23000,16)),
										  47 => std_logic_vector(to_unsigned(23500,16)),
										  48 => std_logic_vector(to_unsigned(24000,16)),
										  49 => std_logic_vector(to_unsigned(24500,16)),
										  50 => std_logic_vector(to_unsigned(25000,16)),
										  51 => std_logic_vector(to_unsigned(25500,16)),
										  52 => std_logic_vector(to_unsigned(26000,16)),
										  53 => std_logic_vector(to_unsigned(26500,16)),
										  54 => std_logic_vector(to_unsigned(27000,16)),
										  55 => std_logic_vector(to_unsigned(27500,16)),
										  56 => std_logic_vector(to_unsigned(28000,16)),
										  57 => std_logic_vector(to_unsigned(28500,16)),
										  58 => std_logic_vector(to_unsigned(29000,16)),
										  59 => std_logic_vector(to_unsigned(29500,16)),
										  60 => std_logic_vector(to_unsigned(30000,16)),
										  61 => std_logic_vector(to_unsigned(30500,16)),
										  62 => std_logic_vector(to_unsigned(31000,16)),
										  63 => std_logic_vector(to_unsigned(31500,16)),
										  64 => std_logic_vector(to_unsigned(32000,16)),
										  65 => std_logic_vector(to_unsigned(32500,16)),
										  66 => std_logic_vector(to_unsigned(33000,16)),
										  67 => std_logic_vector(to_unsigned(33500,16)),
										  68 => std_logic_vector(to_unsigned(34000,16)),
										  69 => std_logic_vector(to_unsigned(34500,16)),
										  70 => std_logic_vector(to_unsigned(35000,16)),
										  71 => std_logic_vector(to_unsigned(35500,16)),
										  72 => std_logic_vector(to_unsigned(36000,16)),
										  73 => std_logic_vector(to_unsigned(36500,16)),
										  74 => std_logic_vector(to_unsigned(37000,16)),
										  75 => std_logic_vector(to_unsigned(37500,16)),
										  76 => std_logic_vector(to_unsigned(38000,16)),
										  77 => std_logic_vector(to_unsigned(38500,16)),
										  78 => std_logic_vector(to_unsigned(39000,16)),
										  79 => std_logic_vector(to_unsigned(39500,16)),
										  80 => std_logic_vector(to_unsigned(40000,16)),
										  81 => std_logic_vector(to_unsigned(40500,16)),
										  82 => std_logic_vector(to_unsigned(41000,16)),
										  83 => std_logic_vector(to_unsigned(41500,16)),
										  84 => std_logic_vector(to_unsigned(42000,16)),
										  85 => std_logic_vector(to_unsigned(42500,16)),
										  86 => std_logic_vector(to_unsigned(43000,16)),
										  87 => std_logic_vector(to_unsigned(43500,16)),
										  88 => std_logic_vector(to_unsigned(44000,16)),
										  89 => std_logic_vector(to_unsigned(44500,16)),
										  90 => std_logic_vector(to_unsigned(45000,16)),
										  91 => std_logic_vector(to_unsigned(45500,16)),
										  92 => std_logic_vector(to_unsigned(46000,16)),
										  93 => std_logic_vector(to_unsigned(46500,16)),
										  94 => std_logic_vector(to_unsigned(47000,16)),
										  95 => std_logic_vector(to_unsigned(47500,16)),
										  96 => std_logic_vector(to_unsigned(48000,16)),
										  97 => std_logic_vector(to_unsigned(48500,16)),
										  98 => std_logic_vector(to_unsigned(49000,16)),
										  99 => std_logic_vector(to_unsigned(50000,16)),
										  others => std_logic_vector(to_unsigned(0,16)));
begin
	data <= duty(to_integer(unsigned(addr)));
end rom;

